from System.Windows.Media import TranslateTransform
from System.Windows import Point, Rect, Size

from playareaitem import PlayAreaItem

class Paddle(PlayAreaItem):
    def __init__(self, play_area, bounds, paddle_element):
        self.play_area = play_area
        self.bounds = bounds
        self.ui_element = paddle_element
        
        self.reset()
        
    def reset(self):
        self.ui_element.RenderTransform = TranslateTransform()

    def clip_move(self):
        maxy = (self.bounds.ActualHeight - self.ui_element.ActualHeight) / 2

        if self.ui_element.RenderTransform.Y < -maxy:
            self.ui_element.RenderTransform.Y = -maxy
        elif self.ui_element.RenderTransform.Y > maxy:
            self.ui_element.RenderTransform.Y = maxy

    def move_down(self):
        self.ui_element.RenderTransform.Y += 8
        self.clip_move()
        
    def move_up(self):
        self.ui_element.RenderTransform.Y -= 8
        self.clip_move()
        